/**
 * Yonius 0.2.0.
 *
 * Copyright (c) 2008-2019 Hive Solutions Lda.
 *
 * This source code is licensed under the Apache 2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('node-fetch')) :
  typeof define === 'function' && define.amd ? define(['exports', 'node-fetch'], factory) :
  (global = global || self, factory(global.yonius = {}, global.fetch));
}(this, function (exports, fetch) { 'use strict';

  fetch = fetch && fetch.hasOwnProperty('default') ? fetch['default'] : fetch;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  var Observable =
  /*#__PURE__*/
  function () {
    function Observable() {
      _classCallCheck(this, Observable);

      this.callbacks = {};
    }

    _createClass(Observable, [{
      key: "bind",
      value: function bind(event, callback) {
        var callbacks = this.callbacks[event] || [];
        callbacks.push(callback);
        this.callbacks[event] = callbacks;
        return callback;
      }
    }, {
      key: "unbind",
      value: function unbind(event, callback) {
        var callbacks = this.callbacks[event] || [];

        if (!callback) {
          delete this.callbacks[event];
          return;
        }

        var index = callbacks.indexOf(callback);

        if (index === -1) {
          return;
        }

        callbacks.splice(index, 1);
        this.callbacks[event] = callbacks;
      }
    }, {
      key: "trigger",
      value: function trigger(event) {
        var callbacks = this.callbacks[event] || [];
        var results = [];
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = callbacks[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var callback = _step.value;
            var result = callback.apply(this, Array.prototype.slice.call(arguments, 1));
            result !== undefined && result !== null && results.push(result);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return Promise.all(results);
      }
    }]);

    return Observable;
  }();

  var verify = function verify(condition) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var exception = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var kwargs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    if (condition) return;
    message = message || "Verification failed";
    var Exception = exception || Error;
    kwargs = Object.assign({}, kwargs);
    if (message !== null && message !== undefined) kwargs.message = message;
    if (code !== null && message !== undefined) kwargs.code = code;
    var throwable = new Exception(kwargs.message || undefined);
    throwable.kwargs = kwargs;
    throw throwable;
  };
  var verifyEqual = function verifyEqual(first, second) {
    var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var code = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var exception = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var kwargs = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    message = message || "Expected ".concat(first, " got ").concat(second);
    return this.verify(first === second, message, code, exception, kwargs);
  };
  var verifyNotEqual = function verifyNotEqual(first, second) {
    var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var code = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var exception = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var kwargs = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    message = message || "Expected ".concat(first, " not equal to ").concat(second);
    return this.verify(first !== second, message, code, exception, kwargs);
  };
  var verifyMany = function verifyMany(sequence) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var exception = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var kwargs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    sequence.forEach(function (element) {
      verify(element, message, code, exception, kwargs);
    });
  };

  var global$1 = typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {};

  const promises = {};

  // Copyright Joyent, Inc. and other Node contributors.
  //
  // Permission is hereby granted, free of charge, to any person obtaining a
  // copy of this software and associated documentation files (the
  // "Software"), to deal in the Software without restriction, including
  // without limitation the rights to use, copy, modify, merge, publish,
  // distribute, sublicense, and/or sell copies of the Software, and to permit
  // persons to whom the Software is furnished to do so, subject to the
  // following conditions:
  //
  // The above copyright notice and this permission notice shall be included
  // in all copies or substantial portions of the Software.
  //
  // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
  // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
  // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
  // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
  // USE OR OTHER DEALINGS IN THE SOFTWARE.
  // resolves . and .. elements in a path array with directory names there
  // must be no slashes, empty elements, or device names (c:\) in the array
  // (so also no leading and trailing slashes - it does not distinguish
  // relative and absolute paths)
  function normalizeArray(parts, allowAboveRoot) {
    // if the path tries to go above the root, `up` ends up > 0
    var up = 0;

    for (var i = parts.length - 1; i >= 0; i--) {
      var last = parts[i];

      if (last === '.') {
        parts.splice(i, 1);
      } else if (last === '..') {
        parts.splice(i, 1);
        up++;
      } else if (up) {
        parts.splice(i, 1);
        up--;
      }
    } // if the path is allowed to go above the root, restore leading ..s


    if (allowAboveRoot) {
      for (; up--; up) {
        parts.unshift('..');
      }
    }

    return parts;
  } // Split a filename into [root, dir, basename, ext], unix version
  // 'root' is just a slash, or nothing.


  var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;

  var splitPath = function splitPath(filename) {
    return splitPathRe.exec(filename).slice(1);
  }; // path.resolve([from ...], to)
  // posix version


  function resolve() {
    var resolvedPath = '',
        resolvedAbsolute = false;

    for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
      var path = i >= 0 ? arguments[i] : '/'; // Skip empty and invalid entries

      if (typeof path !== 'string') {
        throw new TypeError('Arguments to path.resolve must be strings');
      } else if (!path) {
        continue;
      }

      resolvedPath = path + '/' + resolvedPath;
      resolvedAbsolute = path.charAt(0) === '/';
    } // At this point the path should be resolved to a full absolute path, but
    // handle relative paths to be safe (might happen when process.cwd() fails)
    // Normalize the path


    resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function (p) {
      return !!p;
    }), !resolvedAbsolute).join('/');
    return (resolvedAbsolute ? '/' : '') + resolvedPath || '.';
  }
  // posix version

  function normalize(path) {
    var isPathAbsolute = isAbsolute(path),
        trailingSlash = substr(path, -1) === '/'; // Normalize the path

    path = normalizeArray(filter(path.split('/'), function (p) {
      return !!p;
    }), !isPathAbsolute).join('/');

    if (!path && !isPathAbsolute) {
      path = '.';
    }

    if (path && trailingSlash) {
      path += '/';
    }

    return (isPathAbsolute ? '/' : '') + path;
  }

  function isAbsolute(path) {
    return path.charAt(0) === '/';
  } // posix version

  function join() {
    var paths = Array.prototype.slice.call(arguments, 0);
    return normalize(filter(paths, function (p, index) {
      if (typeof p !== 'string') {
        throw new TypeError('Arguments to path.join must be strings');
      }

      return p;
    }).join('/'));
  } // path.relative(from, to)
  function dirname(path) {
    var result = splitPath(path),
        root = result[0],
        dir = result[1];

    if (!root && !dir) {
      // No dirname whatsoever
      return '.';
    }

    if (dir) {
      // It has a dirname, strip trailing slash
      dir = dir.substr(0, dir.length - 1);
    }

    return root + dir;
  }

  function filter(xs, f) {
    if (xs.filter) return xs.filter(f);
    var res = [];

    for (var i = 0; i < xs.length; i++) {
      if (f(xs[i], i, xs)) res.push(xs[i]);
    }

    return res;
  } // String.prototype.substr - negative index don't work in IE8


  var substr = 'ab'.substr(-1) === 'b' ? function (str, start, len) {
    return str.substr(start, len);
  } : function (str, start, len) {
    if (start < 0) start = str.length + start;
    return str.substr(start, len);
  };

  if (typeof global$1.setTimeout === 'function') ;

  if (typeof global$1.clearTimeout === 'function') ;
  var env = {};

  var performance = global$1.performance || {};

  var performanceNow = performance.now || performance.mozNow || performance.msNow || performance.oNow || performance.webkitNow || function () {
    return new Date().getTime();
  }; // generate timestamp or delta

  var HOME_DIR = env["HOME"] || "/";
  var pathExists =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(path) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return promises.access(path);

            case 3:
              _context.next = 8;
              break;

            case 5:
              _context.prev = 5;
              _context.t0 = _context["catch"](0);
              return _context.abrupt("return", false);

            case 8:
              return _context.abrupt("return", true);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 5]]);
    }));

    return function pathExists(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  var expandUser = function expandUser(path) {
    if (!path) return path;
    if (path === "~") return HOME_DIR;
    if (path.slice(0, 2) !== "~/") return path;
    return join(HOME_DIR, path.slice(2));
  };

  var FILE_NAME = "yonius.json";
  var HOME_FILE = "~/.home";
  var IMPORT_NAMES = ["$import", "$include", "$IMPORT", "$INCLUDE"];
  var CASTS = {
    int: function int(v) {
      return typeof v === "number" ? v : parseInt(v);
    },
    float: function float(v) {
      return typeof v === "number" ? v : parseFloat(v);
    },
    bool: function bool(v) {
      return typeof v === "boolean" ? v : ["1", "true", "True"].includes(v);
    },
    list: function list(v) {
      return Array.isArray(v) ? v : v.split(";");
    },
    tuple: function tuple(v) {
      return Array.isArray(v) ? v : v.split(";");
    }
  };
  global$1.CONFIGS = global$1.CONFIGS === undefined ? {} : global$1.CONFIGS;
  global$1.CONFIG_F = global$1.CONFIG_F === undefined ? [] : global$1.CONFIG_F;
  global$1.HOMES = global$1.HOMES === undefined ? [] : global$1.HOMES;
  global$1.LOADED = global$1.LOADED === undefined ? false : global$1.LOADED;
  var conf = function conf(name) {
    var fallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
    var cast = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var ctx = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var configs = ctx ? ctx.configs : global$1.CONFIGS;
    cast = _castR(cast);
    var value = configs[name] === undefined ? fallback : configs[name];
    if (cast && value !== undefined && value !== null) value = cast(value);
    return value;
  };
  var confP =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(name) {
      var fallback,
          cast,
          ctx,
          _args = arguments;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              fallback = _args.length > 1 && _args[1] !== undefined ? _args[1] : undefined;
              cast = _args.length > 2 && _args[2] !== undefined ? _args[2] : null;
              ctx = _args.length > 3 && _args[3] !== undefined ? _args[3] : null;
              _context.next = 5;
              return load();

            case 5:
              return _context.abrupt("return", conf(name, fallback, cast, ctx));

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function confP(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  var confS = function confS(name, value) {
    var ctx = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var configs = ctx ? ctx.configs : global$1.CONFIGS;
    configs[name] = value;
  };
  var load =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      var names,
          path,
          encoding,
          force,
          ctx,
          paths,
          homes,
          _iteratorNormalCompletion,
          _didIteratorError,
          _iteratorError,
          _iterator,
          _step,
          home,
          _iteratorNormalCompletion2,
          _didIteratorError2,
          _iteratorError2,
          _iterator2,
          _step2,
          _path,
          _iteratorNormalCompletion3,
          _didIteratorError3,
          _iteratorError3,
          _iterator3,
          _step3,
          name,
          _args2 = arguments;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              names = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : [FILE_NAME];
              path = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : null;
              encoding = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : "utf-8";
              force = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : false;
              ctx = _args2.length > 4 && _args2[4] !== undefined ? _args2[4] : null;

              if (!(global$1.LOADED && !force)) {
                _context2.next = 7;
                break;
              }

              return _context2.abrupt("return");

            case 7:
              paths = [];
              _context2.next = 10;
              return getHomes();

            case 10:
              homes = _context2.sent;
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context2.prev = 14;

              for (_iterator = homes[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                home = _step.value;
                paths = paths.concat([join(home), join(home, ".config")]);
              }

              _context2.next = 22;
              break;

            case 18:
              _context2.prev = 18;
              _context2.t0 = _context2["catch"](14);
              _didIteratorError = true;
              _iteratorError = _context2.t0;

            case 22:
              _context2.prev = 22;
              _context2.prev = 23;

              if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
              }

            case 25:
              _context2.prev = 25;

              if (!_didIteratorError) {
                _context2.next = 28;
                break;
              }

              throw _iteratorError;

            case 28:
              return _context2.finish(25);

            case 29:
              return _context2.finish(22);

            case 30:
              if (path) paths.push(path);
              _iteratorNormalCompletion2 = true;
              _didIteratorError2 = false;
              _iteratorError2 = undefined;
              _context2.prev = 34;
              _iterator2 = paths[Symbol.iterator]();

            case 36:
              if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                _context2.next = 67;
                break;
              }

              _path = _step2.value;
              _iteratorNormalCompletion3 = true;
              _didIteratorError3 = false;
              _iteratorError3 = undefined;
              _context2.prev = 41;
              _iterator3 = names[Symbol.iterator]();

            case 43:
              if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                _context2.next = 50;
                break;
              }

              name = _step3.value;
              _context2.next = 47;
              return loadFile(name, _path, encoding, ctx);

            case 47:
              _iteratorNormalCompletion3 = true;
              _context2.next = 43;
              break;

            case 50:
              _context2.next = 56;
              break;

            case 52:
              _context2.prev = 52;
              _context2.t1 = _context2["catch"](41);
              _didIteratorError3 = true;
              _iteratorError3 = _context2.t1;

            case 56:
              _context2.prev = 56;
              _context2.prev = 57;

              if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
                _iterator3.return();
              }

            case 59:
              _context2.prev = 59;

              if (!_didIteratorError3) {
                _context2.next = 62;
                break;
              }

              throw _iteratorError3;

            case 62:
              return _context2.finish(59);

            case 63:
              return _context2.finish(56);

            case 64:
              _iteratorNormalCompletion2 = true;
              _context2.next = 36;
              break;

            case 67:
              _context2.next = 73;
              break;

            case 69:
              _context2.prev = 69;
              _context2.t2 = _context2["catch"](34);
              _didIteratorError2 = true;
              _iteratorError2 = _context2.t2;

            case 73:
              _context2.prev = 73;
              _context2.prev = 74;

              if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                _iterator2.return();
              }

            case 76:
              _context2.prev = 76;

              if (!_didIteratorError2) {
                _context2.next = 79;
                break;
              }

              throw _iteratorError2;

            case 79:
              return _context2.finish(76);

            case 80:
              return _context2.finish(73);

            case 81:
              _context2.next = 83;
              return loadEnv(ctx);

            case 83:
              global$1.LOADED = true;

            case 84:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[14, 18, 22, 30], [23,, 25, 29], [34, 69, 73, 81], [41, 52, 56, 64], [57,, 59, 63], [74,, 76, 80]]);
    }));

    return function load() {
      return _ref2.apply(this, arguments);
    };
  }();
  var loadFile =
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3() {
      var name,
          path,
          encoding,
          ctx,
          configs,
          configF,
          key,
          value,
          exists,
          filePath,
          basePath,
          data,
          dataJ,
          _arr,
          _i,
          _arr$_i,
          _args3 = arguments;

      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              name = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : FILE_NAME;
              path = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : null;
              encoding = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : "utf-8";
              ctx = _args3.length > 3 && _args3[3] !== undefined ? _args3[3] : null;
              configs = ctx ? ctx.configs : global$1.CONFIGS;
              configF = ctx ? ctx.configF : global$1.CONFIG_F;
              if (path) path = normalize(path);
              if (path) filePath = join(path, name);else filePath = name;
              filePath = resolve(filePath);
              filePath = normalize(filePath);
              basePath = dirname(filePath);
              _context3.next = 13;
              return pathExists(filePath);

            case 13:
              exists = _context3.sent;

              if (exists) {
                _context3.next = 16;
                break;
              }

              return _context3.abrupt("return");

            case 16:
              exists = configF.includes(filePath);
              if (exists) configF.splice(configF.indexOf(filePath), 1);
              configF.push(filePath);
              _context3.next = 21;
              return promises.readFile(filePath, {
                encoding: encoding
              });

            case 21:
              data = _context3.sent;
              dataJ = JSON.parse(data);
              _context3.next = 25;
              return _loadIncludes(basePath, dataJ, encoding);

            case 25:
              _arr = Object.entries(dataJ);
              _i = 0;

            case 27:
              if (!(_i < _arr.length)) {
                _context3.next = 37;
                break;
              }

              _arr$_i = _slicedToArray(_arr[_i], 2);
              key = _arr$_i[0];
              value = _arr$_i[1];

              if (_isValid(key)) {
                _context3.next = 33;
                break;
              }

              return _context3.abrupt("continue", 34);

            case 33:
              configs[key] = value;

            case 34:
              _i++;
              _context3.next = 27;
              break;

            case 37:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function loadFile() {
      return _ref3.apply(this, arguments);
    };
  }();
  var loadEnv =
  /*#__PURE__*/
  function () {
    var _ref4 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4() {
      var ctx,
          configs,
          _args4 = arguments;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              ctx = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : null;
              configs = ctx ? ctx.configs : global$1.CONFIGS;

              if (!(env === undefined || env === null)) {
                _context4.next = 4;
                break;
              }

              return _context4.abrupt("return");

            case 4:
              Object.entries(env).forEach(function (_ref5) {
                var _ref6 = _slicedToArray(_ref5, 2),
                    key = _ref6[0],
                    value = _ref6[1];

                configs[key] = value;
              });

            case 5:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function loadEnv() {
      return _ref4.apply(this, arguments);
    };
  }();
  var getHomes =
  /*#__PURE__*/
  function () {
    var _ref7 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5() {
      var filePath,
          fallback,
          encoding,
          forceDefault,
          exists,
          data,
          paths,
          _iteratorNormalCompletion4,
          _didIteratorError4,
          _iteratorError4,
          _iterator4,
          _step4,
          path,
          _args5 = arguments;

      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              filePath = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : HOME_FILE;
              fallback = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : "~";
              encoding = _args5.length > 2 && _args5[2] !== undefined ? _args5[2] : "utf-8";
              forceDefault = _args5.length > 3 && _args5[3] !== undefined ? _args5[3] : false;

              if (!(global$1.HOMES.length > 0)) {
                _context5.next = 6;
                break;
              }

              return _context5.abrupt("return", global$1.HOMES);

            case 6:
              global$1.HOMES = env.HOMES === undefined ? null : env.HOMES;
              global$1.HOMES = global$1.HOMES ? global$1.HOMES.split(";") : global$1.HOMES;

              if (!(global$1.HOMES !== null)) {
                _context5.next = 10;
                break;
              }

              return _context5.abrupt("return", global$1.HOMES);

            case 10:
              fallback = expandUser(fallback);
              fallback = normalize(fallback);
              global$1.HOMES = [fallback];
              filePath = expandUser(filePath);
              filePath = normalize(filePath);
              _context5.next = 17;
              return pathExists(filePath);

            case 17:
              exists = _context5.sent;

              if (exists) {
                _context5.next = 20;
                break;
              }

              return _context5.abrupt("return", global$1.HOMES);

            case 20:
              if (!forceDefault) global$1.HOMES.splice(0, global$1.HOMES.length);
              _context5.next = 23;
              return promises.readFile(filePath, {
                encoding: encoding
              });

            case 23:
              data = _context5.sent;
              data = data.trim();
              paths = data.split(/\r?\n/);
              paths = paths.map(function (v) {
                return v.trim();
              });
              _iteratorNormalCompletion4 = true;
              _didIteratorError4 = false;
              _iteratorError4 = undefined;
              _context5.prev = 30;
              _iterator4 = paths[Symbol.iterator]();

            case 32:
              if (_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done) {
                _context5.next = 43;
                break;
              }

              path = _step4.value;
              path = path.trim();

              if (path) {
                _context5.next = 37;
                break;
              }

              return _context5.abrupt("continue", 40);

            case 37:
              path = expandUser(path);
              path = normalize(path);
              global$1.HOMES.push(path);

            case 40:
              _iteratorNormalCompletion4 = true;
              _context5.next = 32;
              break;

            case 43:
              _context5.next = 49;
              break;

            case 45:
              _context5.prev = 45;
              _context5.t0 = _context5["catch"](30);
              _didIteratorError4 = true;
              _iteratorError4 = _context5.t0;

            case 49:
              _context5.prev = 49;
              _context5.prev = 50;

              if (!_iteratorNormalCompletion4 && _iterator4.return != null) {
                _iterator4.return();
              }

            case 52:
              _context5.prev = 52;

              if (!_didIteratorError4) {
                _context5.next = 55;
                break;
              }

              throw _iteratorError4;

            case 55:
              return _context5.finish(52);

            case 56:
              return _context5.finish(49);

            case 57:
              return _context5.abrupt("return", global$1.HOMES);

            case 58:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, null, [[30, 45, 49, 57], [50,, 52, 56]]);
    }));

    return function getHomes() {
      return _ref7.apply(this, arguments);
    };
  }();
  var _castR = function _castR(cast) {
    return CASTS[cast] === undefined ? cast : CASTS[cast];
  };
  var _loadIncludes =
  /*#__PURE__*/
  function () {
    var _ref8 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(basePath, config) {
      var encoding,
          includes,
          _arr2,
          _i2,
          alias,
          _iteratorNormalCompletion5,
          _didIteratorError5,
          _iteratorError5,
          _iterator5,
          _step5,
          include,
          _args6 = arguments;

      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              encoding = _args6.length > 2 && _args6[2] !== undefined ? _args6[2] : "utf-8";
              includes = [];
              _arr2 = IMPORT_NAMES;

              for (_i2 = 0; _i2 < _arr2.length; _i2++) {
                alias = _arr2[_i2];
                includes = config[alias] === undefined ? includes : config[alias];
              }

              if (typeof includes === "string") {
                includes = includes.split(";");
              }

              _iteratorNormalCompletion5 = true;
              _didIteratorError5 = false;
              _iteratorError5 = undefined;
              _context6.prev = 8;
              _iterator5 = includes[Symbol.iterator]();

            case 10:
              if (_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done) {
                _context6.next = 17;
                break;
              }

              include = _step5.value;
              _context6.next = 14;
              return loadFile(include, basePath, encoding);

            case 14:
              _iteratorNormalCompletion5 = true;
              _context6.next = 10;
              break;

            case 17:
              _context6.next = 23;
              break;

            case 19:
              _context6.prev = 19;
              _context6.t0 = _context6["catch"](8);
              _didIteratorError5 = true;
              _iteratorError5 = _context6.t0;

            case 23:
              _context6.prev = 23;
              _context6.prev = 24;

              if (!_iteratorNormalCompletion5 && _iterator5.return != null) {
                _iterator5.return();
              }

            case 26:
              _context6.prev = 26;

              if (!_didIteratorError5) {
                _context6.next = 29;
                break;
              }

              throw _iteratorError5;

            case 29:
              return _context6.finish(26);

            case 30:
              return _context6.finish(23);

            case 31:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, null, [[8, 19, 23, 31], [24,, 26, 30]]);
    }));

    return function _loadIncludes(_x2, _x3) {
      return _ref8.apply(this, arguments);
    };
  }();
  var _isValid = function _isValid(key) {
    if (IMPORT_NAMES.includes(key)) return false;
    return true;
  };
  var _isDevel = function _isDevel() {
    return ["DEBUG"].includes(conf("LEVEL", "INFO"));
  };
  var _isSecure = function _isSecure() {
    return conf("SECURE", true, "bool");
  };

  var MixinBuilder =
  /*#__PURE__*/
  function () {
    function MixinBuilder(superclass) {
      _classCallCheck(this, MixinBuilder);

      this.superclass = superclass;
    }

    _createClass(MixinBuilder, [{
      key: "with",
      value: function _with() {
        for (var _len = arguments.length, mixins = new Array(_len), _key = 0; _key < _len; _key++) {
          mixins[_key] = arguments[_key];
        }

        return mixins.reduce(function (c, mixin) {
          return mixin(c);
        }, this.superclass);
      }
    }]);

    return MixinBuilder;
  }();
  var mix = function mix(superclass) {
    return new MixinBuilder(superclass);
  };

  var urlEncode = function urlEncode(values) {
    // constructs the parts array that is going to
    // store the multiple and values
    var parts = []; // in case the provided value is not an array
    // then assumes it's an object and retrieve entries

    if (!Array.isArray(values)) {
      values = Object.entries(values);
    } // iterates over the complete set of pairs available
    // from the key value pairs to be able to encode them
    // properly, notice that the values themselves can be
    // sequences allowing multiple repetition of key


    values.forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          key = _ref2[0],
          value = _ref2[1];

      if (!Array.isArray(value)) {
        value = [value];
      }

      var keyEncoded = encodeURIComponent(key);
      value.forEach(function (_value) {
        if (_value === undefined || _value === null) {
          return;
        }

        var valueEncoded = encodeURIComponent(_value);
        parts.push("".concat(keyEncoded, "=").concat(valueEncoded));
      });
    }); // joins the complete set of parts with the and
    // separator and then returns the final string value

    return parts.join("&");
  };

  var API =
  /*#__PURE__*/
  function (_Observable) {
    _inherits(API, _Observable);

    function API() {
      var _this;

      var kwargs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      _classCallCheck(this, API);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(API).call(this));
      _this.kwargs = kwargs;
      return _this;
    }

    _createClass(API, [{
      key: "build",
      value: function () {
        var _build = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(method, url) {
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:


                case 1:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function build(_x, _x2) {
          return _build.apply(this, arguments);
        }

        return build;
      }()
    }, {
      key: "get",
      value: function () {
        var _get = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee2(url) {
          var options,
              params,
              headers,
              kwargs,
              handle,
              query,
              response,
              result,
              _args2 = arguments;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  options = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : {};
                  params = options.params !== undefined ? options.params : {};
                  headers = options.headers !== undefined ? options.headers : {};
                  kwargs = options.kwargs !== undefined ? options.kwargs : {};
                  handle = options.handle !== undefined ? options.handle : true;
                  this.build("GET", url, {
                    params: params,
                    headers: headers,
                    kwargs: kwargs
                  });
                  query = urlEncode(params || {});
                  if (query) url += url.includes("?") ? "&" + query : "?" + query;
                  _context2.next = 10;
                  return fetch(url, {
                    method: "GET",
                    headers: headers || {}
                  });

                case 10:
                  response = _context2.sent;

                  if (!handle) {
                    _context2.next = 17;
                    break;
                  }

                  _context2.next = 14;
                  return this._handleResponse(response);

                case 14:
                  _context2.t0 = _context2.sent;
                  _context2.next = 18;
                  break;

                case 17:
                  _context2.t0 = response;

                case 18:
                  result = _context2.t0;
                  return _context2.abrupt("return", result);

                case 20:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function get(_x3) {
          return _get.apply(this, arguments);
        }

        return get;
      }()
    }, {
      key: "post",
      value: function () {
        var _post = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee3(url) {
          var options,
              params,
              headers,
              data,
              dataJ,
              dataM,
              mime,
              kwargs,
              handle,
              query,
              response,
              result,
              _args3 = arguments;
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  options = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
                  params = options.params !== undefined ? options.params : {};
                  headers = options.headers !== undefined ? options.headers : {};
                  data = options.data !== undefined ? options.data : null;
                  dataJ = options.dataJ !== undefined ? options.dataJ : null;
                  dataM = options.dataM !== undefined ? options.dataM : null;
                  mime = options.mime !== undefined ? options.mime : null;
                  kwargs = options.kwargs !== undefined ? options.kwargs : null;
                  handle = options.handle !== undefined ? options.handle : true;
                  this.build("POST", url, {
                    params: params,
                    headers: headers,
                    data: data,
                    dataJ: dataJ,
                    dataM: dataM,
                    mime: mime,
                    kwargs: kwargs
                  });
                  query = urlEncode(params || {});

                  if (data !== null) {
                    if (query) url += url.includes("?") ? "&" + query : "?" + query;
                  } else if (dataJ !== null) {
                    data = JSON.stringify(dataJ);
                    if (query) url += url.includes("?") ? "&" + query : "?" + query;
                    mime = mime || "application/json";
                  } else if (dataM !== null) {
                    if (query) url += url.includes("?") ? "&" + query : "?" + query;
                  } else if (query) {
                    data = query;
                    mime = mime || "application/x-www-form-urlencoded";
                  }

                  headers = Object.assign({}, headers);
                  if (mime) headers["Content-Type"] = mime;
                  _context3.next = 16;
                  return fetch(url, {
                    method: "POST",
                    headers: headers || {},
                    body: data
                  });

                case 16:
                  response = _context3.sent;

                  if (!handle) {
                    _context3.next = 23;
                    break;
                  }

                  _context3.next = 20;
                  return this._handleResponse(response);

                case 20:
                  _context3.t0 = _context3.sent;
                  _context3.next = 24;
                  break;

                case 23:
                  _context3.t0 = response;

                case 24:
                  result = _context3.t0;
                  return _context3.abrupt("return", result);

                case 26:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this);
        }));

        function post(_x4) {
          return _post.apply(this, arguments);
        }

        return post;
      }()
    }, {
      key: "_handleResponse",
      value: function () {
        var _handleResponse2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee4(response) {
          var result;
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  result = null;

                  if (!(response.headers.get("content-type").toLowerCase() === "application/json")) {
                    _context4.next = 7;
                    break;
                  }

                  _context4.next = 4;
                  return response.json();

                case 4:
                  result = _context4.sent;
                  _context4.next = 10;
                  break;

                case 7:
                  _context4.next = 9;
                  return response.blob();

                case 9:
                  result = _context4.sent;

                case 10:
                  return _context4.abrupt("return", result);

                case 11:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        }));

        function _handleResponse(_x5) {
          return _handleResponse2.apply(this, arguments);
        }

        return _handleResponse;
      }()
    }]);

    return API;
  }(Observable);

  var OAuthAPI =
  /*#__PURE__*/
  function (_API) {
    _inherits(OAuthAPI, _API);

    function OAuthAPI() {
      _classCallCheck(this, OAuthAPI);

      return _possibleConstructorReturn(this, _getPrototypeOf(OAuthAPI).apply(this, arguments));
    }

    return OAuthAPI;
  }(API);

  var OAuth1API =
  /*#__PURE__*/
  function (_OAuthAPI) {
    _inherits(OAuth1API, _OAuthAPI);

    function OAuth1API() {
      _classCallCheck(this, OAuth1API);

      return _possibleConstructorReturn(this, _getPrototypeOf(OAuth1API).apply(this, arguments));
    }

    return OAuth1API;
  }(OAuthAPI);

  var OAuth2API =
  /*#__PURE__*/
  function (_OAuthAPI) {
    _inherits(OAuth2API, _OAuthAPI);

    function OAuth2API() {
      _classCallCheck(this, OAuth2API);

      return _possibleConstructorReturn(this, _getPrototypeOf(OAuth2API).apply(this, arguments));
    }

    return OAuth2API;
  }(OAuthAPI);

  var load$1 =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return load();

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function load() {
      return _ref.apply(this, arguments);
    };
  }();

  exports.API = API;
  exports.MixinBuilder = MixinBuilder;
  exports.OAuth1API = OAuth1API;
  exports.OAuth2API = OAuth2API;
  exports.OAuthAPI = OAuthAPI;
  exports.Observable = Observable;
  exports._castR = _castR;
  exports._isDevel = _isDevel;
  exports._isSecure = _isSecure;
  exports._isValid = _isValid;
  exports.conf = conf;
  exports.confP = confP;
  exports.confS = confS;
  exports.expandUser = expandUser;
  exports.load = load$1;
  exports.loadConf = load;
  exports.mix = mix;
  exports.pathExists = pathExists;
  exports.urlEncode = urlEncode;
  exports.verify = verify;
  exports.verifyEqual = verifyEqual;
  exports.verifyMany = verifyMany;
  exports.verifyNotEqual = verifyNotEqual;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=yonius.umd.js.map
